/*****************************************************************************************************************************
--
--    File Name    : ramDualPort_bayer.v 

--    Description  : This module implements dual port ram .

-- Targeted device : Microsemi-SoC                     
-- Author          : India Solutions Team

-- SVN Revision Information:
-- SVN $Revision: TBD
-- SVN $Date: TBD
--
--
--
-- COPYRIGHT 2016 BY MICROSEMI 
-- THE INFORMATION CONTAINED IN THIS DOCUMENT IS SUBJECT TO LICENSING RESTRICTIONS 
-- FROM MICROSEMI CORP.  IF YOU ARE NOT IN POSSESSION OF WRITTEN AUTHORIZATION FROM 
-- MICROSEMI FOR USE OF THIS FILE, THEN THE FILE SHOULD BE IMMEDIATELY DESTROYED AND 
-- NO BACK-UP OF THE FILE SHOULD BE MADE. 
-- 

--******************************************************************************************************************************/

module ramDualPort_bayer #(parameter DATA_WIDTH = 8,
                           parameter ADDRESS_WIDTH = 8,
                           parameter BUFF_DEPTH = 1280)
                         (input[DATA_WIDTH - 1 : 0] data_a,
                          input[ADDRESS_WIDTH - 1 : 0] addr_a,
                          input[ADDRESS_WIDTH - 1 : 0] addr_b,
                          input we_a,
                          input we_b,
                          input clk,
                          output reg[DATA_WIDTH - 1 : 0] q_b);
  reg[DATA_WIDTH - 1 : 0] li0[BUFF_DEPTH - 1 : 0]/* synthesis syn_ramstyle="lsram" */;
  always
    @(posedge clk)
    begin
      if (we_a)
        begin
          li0[addr_a] <= data_a;
        end
      else
        begin
        end
    end
  always
    @(posedge clk)
    begin
      if (we_b)
        begin
        end
      else
        begin
          q_b <= li0[addr_b];
        end
    end
endmodule
